% Dit is het simulatiemodel van 
% A. de Klerk en
% J.M. Meulepas
% ten bate van hun afstudeerwerk.
%
Zmax = 1.50;                                                        % Kolomhoogte (m)
g = 9.81;                                                           % Valversnelling door zwaartekracht (m/s2)
delta = 1.65;                                                       % Relatieve dichtheid zand t.o.v. water (-)
invoeropnieuw=0                                                     % In iedergeval 1 keer invoer
epsilonopnieuw=0
format short e

% Invoer routine
while invoeropnieuw ~= 1   
   clc;
   disp(['Voor de bepaling van de viscositeit is de temperatuur '])
   disp(['nodig. Deze kan worden ingevoer in graden Celcius. '])
   disp(['De temperatuur moet liggen tussen de 10 en 40 graden'])
   invoer = input('Geef de temperatuur (C) tijdens de proef : ');
   while invoer<10 | invoer>40
      invoer = input('Fout. Geef opnieuw de temperatuur (C) tijdens de proef : ');
   end
   Temp=invoer;                                                         % Temperatuur (Celsius)  
   visc=40*10^(-6)/(20+Temp);                                           % Viscositeit (m2/s)
   
   clc
   disp(['Voor de bepaling van de valsnelheid wordt de empirische '])
   disp(['formule van Ruby gebruikt. Deze formule is voldoende nauwkeurig '])
   disp(['voor het gebied van D50 = 80mu tot D50 = 1200 mu'])
   invoer = input('Geef de D50 van de gebruikte korrelfractie in micrometers : ');
   while invoer<80 | invoer>1200
      invoer = input('Fout. Geef opnieuw de D50 van de gebruikte korrelfractie in micrometers : ');
   end
   d50=invoer/1000000;                                                  % D50 in meters
   w0=(10*visc/d50)*(-1+(sqrt(1+((delta*g*(d50^3))/(100*visc^2)))));    % Ongestoorde valsnelheid (m/s)
   Re=w0*d50/visc;                                                      % Reynoldgetal
   n=(5.1+(0.27*Re^(0.9)))/(1+(0.1*Re^(0.9)));                          % n 'Hindered Settling'
   
   clc
   disp(['In verband met het inzanden van het model is het van belang dat er '])
   disp(['een maximale concentratie wordt in gegeven. Deze moet tussen '])
   disp(['de 40 en 70 % liggen.'])
   invoer = input('Geef de Cmax (%) waarbij het model moet inzanden : ');
   while invoer<40 | invoer>70
      invoer = input('Fout. Geef opnieuw de Cmax (%) waarbij het model moet inzanden : ');
   end
   Cmax=invoer/100;                                                    % Cmax (-)
   clc
   disp([''])
   disp(['Geef nu de begin concentratie C0 (%).'])
   uitvoer = num2str(Cmax*100);
   disp(['De waarde moet liggen tussen de 0 en ' uitvoer '(%)liggen.'])
   invoer = input('Geef de beginconcentratie (%) voor het model : ');
   while invoer<0 | invoer>(Cmax*100)
      invoer = input('Fout. Geef opnieuw de beginconcentratie (%) voor het model : ');
   end
   C0=invoer/100;                                                      % C0 (-)
   
   clc
   disp(['Voor het model is het van belang dat u een waarde voor de  '])
   disp(['turbulente diffusicoeffitient (epsilon) ingeeft.'])
   disp(['Epsilon moet liggen tussen de 0 en 0.0100 [m2/s] '])
   invoer = input('Geef de epsilon voor dit model : ');
   while invoer<0 | invoer>0.0100
      invoer = input('Fout. Geef opnieuw de epsilon voor dit model : ');
   end
   Eps=invoer;                                                         % Eps (m2/s)
   disp([' '])
   disp(['Voor het numerieke model is het van belang dat u '])
   disp(['een stapgrootte in de hoogte ingeeft(dz).'])
   uitvoer = num2str(2*Eps/w0);
   disp(['De stapgrootte in de hoogte moet liggen tussen de 0 en de ' uitvoer ' meter'])
   invoer = input('Geef de stapgrootte (dz) voor dit model : ');
   %while invoer<0 | invoer>(2*Eps/w0)
   %   invoer = input('Fout. Geef opnieuw de stapgrootte (dz) voor dit model : ');
   %end
   dz=invoer;                                                      % dz (m)
   
   disp([' '])
   disp(['Voor het model is het is het ook van belang om een '])
   disp(['tijdstap te hebben. Deze tijdstap moet liggen '])
   uitvoer = num2str(((dz^2)/(Eps))*(1/2));
   disp(['tussen de 0 en de ' uitvoer ' seconden '])
   uitvoer = num2str(((dz^2)/(Eps))*1/6);
   disp(['Voor de grootste nauwkeurigheid moet u een waarde van ' uitvoer ' seconden kiezen '])
   invoer = input('Geef de tijdstap (dt) voor dit model : ');
   while invoer<0 | invoer>(((dz^2)/(Eps))/(1/2))
      invoer = input('Fout. Geef opnieuw de tijdstap (dt) voor dit model : ');
   end
   dt=invoer;                                                         % dt (s)

   disp([' '])
   disp(['Tenslotte is er een eindtijd voor de simulatie gewenst. '])
   disp(['Geef Tmax in seconden.'])
   disp(['Tmax moet tussende 0 en 1800 s liggen '])
   invoer = input('Geef de eindtijd in seconden voor dit model : ');
   while invoer<0 | invoer>1800
      invoer = input('Fout. Geef opnieuw de eindtijd in seconden voor dit model : ');
   end
   Tmax=invoer;                                                        % Eindtijd (s)
   

   
   clc
   
   disp(['U heeft het volgende in gevoerd:'])
   disp(['Temperatuur: ' num2str(Temp) ' graden Celcius.'])
   disp(['D50:         ' num2str(d50*1000000) ' micrometer.'])
   disp(['Cmax:        ' num2str(Cmax*100) ' (%).'])
   disp(['C0:          ' num2str(C0*100) ' (%).'])
   disp(['Epsilon:     ' num2str(Eps) ' m2/s.'])
   disp(['dz:          ' num2str(dz) ' m.'])
   disp(['dt:          ' num2str(dt) ' s.'])
   disp(['Tmax         ' num2str(Tmax) ' s.'])  
   invoer = input (['Klopt het boverstaande? "1" = "JA" : ']);
   invoeropnieuw=invoer;
   clc;
end

% Hoofdroutine
clear C;
for h=1 : 1 :((Zmax/dz)+1)                 %t=0
   C(1,h)=C0;
end
%ok
for t=1 : 1 : ((Tmax/dt)+1)
   h=1;                                     %Bovenrand
   C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h+1)-C(t,h))/(dz^2))-(dt*((C(t,h)*w0*(1-C(t,h))^n)+(C(t,h+1)*w0*(1-C(t,h+1))^n))/(2*dz));
   for h=2 : 1 : ((Zmax/dz))                %Middeldeel
      if C(t,h)>=Cmax; 
         C(t,h)=Cmax;
      end
      if C(t,h+1)>=Cmax;
         C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-C(t,h))/(dz^2))+(dt*((C(t,h-1)*w0*(1-C(t,h-1))^n)+(C(t,h)*w0*(1-C(t,h))^n))/(2*dz));
      else
         C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-2*C(t,h)+C(t,h+1))/(dz^2))-(dt*((C(t,h+1)*w0*(1-C(t,h+1))^n)-(C(t,h-1)*w0*(1-C(t,h-1))^n))/(2*dz));
      end
      
   end
                              %Onderrand
   C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-C(t,h))/(dz^2))+(dt*((C(t,h-1)*w0*(1-C(t,h-1))^n)+(C(t,h)*w0*(1-C(t,h))^n))/(2*dz));
end
if C(t+1,h)>=Cmax;
   C(t+1,h)=Cmax;
end

%Maken tijd matrix
clear Tijd
for k=1 : 1 : ((Tmax/dt)+2)
   Tijd(k)=(dt*(k-1));
end
Tijd=Tijd';
%Maken plaats matrix
clear Plaats
for k=1 : 1 : ((Zmax/dz)+1)
   Plaats(k)=(dz*(k-1));
end
%Maken grafiekje
clf
hold on
for k=1:1:12
   plot (Tijd,C(:,(fix((Zmax/dz)*(k+1)/15))))
end
title ('Concentratie op verschillende hoogten over de tijd')
xlabel('Tijd, seconden')
ylabel('Concentratie, (-)')
axis([0 Tmax 0 0.7])
grid
for k=1:1:12
   text((fix(Tmax)),C((fix(Tmax/dt)),(fix((Zmax/dz)*(k+1)/15))),int2str(13-k))
end

hold off

clc
disp(['U heeft het volgende in gevoerd:'])
disp(['Temperatuur: ' num2str(Temp) ' graden Celcius.'])
disp(['D50:         ' num2str(d50*1000000) ' micrometer.'])
disp(['Cmax:        ' num2str(Cmax*100) ' (%).'])
disp(['C0:          ' num2str(C0*100) ' (%).'])
disp(['Epsilon:     ' num2str(Eps) ' m2/s.'])
disp(['dz:          ' num2str(dz) ' m.'])
disp(['dt:          ' num2str(dt) ' s.'])
disp(['Tmax         ' num2str(Tmax) ' s.'])  

invoer = input (['Wilt u alleen epsilon opnieuw invoeren? "1" = "JA" : ']);
epsilonopnieuw=invoer;
while epsilonopnieuw == 1
  clc
   disp(['Voor het model is het van belang dat u een waarde voor de  '])
   disp(['turbulente diffusicoeffitient (epsilon) ingeeft.'])
   disp(['Epsilon moet liggen tussen de 0 en 0.0100 [m2/s] '])
   invoer = input('Geef de epsilon voor dit model : ');
   while invoer<0 | invoer>0.0100
      invoer = input('Fout. Geef opnieuw de epsilon voor dit model : ');
   end
   Eps=invoer;                                                         % Eps (m2/s)
   disp([' '])
   disp(['Voor het numerieke model is het van belang dat u '])
   disp(['een stapgrootte in de hoogte ingeeft(dz).'])
   uitvoer = num2str(2*Eps/w0);
   disp(['De stapgrootte in de hoogte moet liggen tussen de 0 en de ' uitvoer ' meter'])
   invoer = input('Geef de stapgrootte (dz) voor dit model : ');
   %while invoer<0 | invoer>(2*Eps/w0)
   %   invoer = input('Fout. Geef opnieuw de stapgrootte (dz) voor dit model : ');
   %end
   dz=invoer;                                                      % dz (m)
   
   disp([' '])
   disp(['Voor het model is het is het ook van belang om een '])
   disp(['tijdstap te hebben. Deze tijdstap moet liggen '])
   uitvoer = num2str(((dz^2)/(Eps))*(1/2));
   disp(['tussen de 0 en de ' uitvoer ' seconden '])
   uitvoer = num2str(((dz^2)/(Eps))*1/6);
   disp(['Voor de grootste nauwkeurigheid moet u een waarde van ' uitvoer ' seconden kiezen '])
   invoer = input('Geef de tijdstap (dt) voor dit model : ');
   while invoer<0 | invoer>(((dz^2)/(Eps))/(1/2))
      invoer = input('Fout. Geef opnieuw de tijdstap (dt) voor dit model : ');
   end
   dt=invoer;                                                         % dt (s)

   disp([' '])
   disp(['Tenslotte is er een eindtijd voor de simulatie gewenst. '])
   disp(['Geef Tmax in seconden.'])
   disp(['Tmax moet tussende 0 en 1800 s liggen '])
   invoer = input('Geef de eindtijd in seconden voor dit model : ');
   while invoer<0 | invoer>1800
      invoer = input('Fout. Geef opnieuw de eindtijd in seconden voor dit model : ');
   end
   Tmax=invoer;                                                        % Eindtijd (s)
    
   clc
   
   disp(['U heeft het volgende in gevoerd:'])
   disp(['Temperatuur: ' num2str(Temp) ' graden Celcius.'])
   disp(['D50:         ' num2str(d50*1000000) ' micrometer.'])
   disp(['Cmax:        ' num2str(Cmax*100) ' (%).'])
   disp(['C0:          ' num2str(C0*100) ' (%).'])
   disp(['Epsilon:     ' num2str(Eps) ' m2/s.'])
   disp(['dz:          ' num2str(dz) ' m.'])
   disp(['dt:          ' num2str(dt) ' s.'])
   disp(['Tmax         ' num2str(Tmax) ' s.'])  
   pause
   epsilonopnieuw=0;
   clc;


% Hoofdroutine
clear C;
for h=1 : 1 :((Zmax/dz)+1)                 %t=0
   C(1,h)=C0;
end
%ok
for t=1 : 1 : ((Tmax/dt)+1)
   h=1;                                     %Bovenrand
   C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h+1)-C(t,h))/(dz^2))-(dt*((C(t,h)*w0*(1-C(t,h))^n)+(C(t,h+1)*w0*(1-C(t,h+1))^n))/(2*dz));
   for h=2 : 1 : ((Zmax/dz))                %Middeldeel
      if C(t,h)>=Cmax; 
         C(t,h)=Cmax;
      end
      if C(t,h+1)>=Cmax;
         C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-C(t,h))/(dz^2))+(dt*((C(t,h-1)*w0*(1-C(t,h-1))^n)+(C(t,h)*w0*(1-C(t,h))^n))/(2*dz));
      else
         C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-2*C(t,h)+C(t,h+1))/(dz^2))-(dt*((C(t,h+1)*w0*(1-C(t,h+1))^n)-(C(t,h-1)*w0*(1-C(t,h-1))^n))/(2*dz));
      end
      
   end
                              %Onderrand
   C(t+1,h)=C(t,h)+(Eps*dt*(C(t,h-1)-C(t,h))/(dz^2))+(dt*((C(t,h-1)*w0*(1-C(t,h-1))^n)+(C(t,h)*w0*(1-C(t,h))^n))/(2*dz));
end
if C(t+1,h)>=Cmax;
   C(t+1,h)=Cmax;
end

%Maken tijd matrix
clear Tijd
for k=1 : 1 : ((Tmax/dt)+2)
   Tijd(k)=(dt*(k-1));
end
Tijd=Tijd';
%Maken plaats matrix
clear Plaats
for k=1 : 1 : ((Zmax/dz)+1)
   Plaats(k)=(dz*(k-1));
end
%Maken grafiekje
clf
hold on
for k=1:1:12
   plot (Tijd,C(:,(fix((Zmax/dz)*(k+1)/15))))
   axis ([0 Tmax 0 0.7])
end
title ('Concentratie op verschillende hoogten over de tijd')
xlabel('Tijd, seconden')
ylabel('Concentratie, (-)')
axis([0 Tmax 0 0.7])
grid
for k=1:1:12
   text((fix(Tmax)),C((fix(Tmax/dt)),(fix((Zmax/dz)*(k+1)/15))),int2str(13-k))
end

hold off
invoer = input (['Wilt u alleen epsilon opnieuw invoeren? "1" = "JA" : ']);
epsilonopnieuw=invoer;
end